[ORG 0x0100]

[SEGMENT .text]		;Main code segment

start:

    mov  al,byte [80h]

    mov  bx,81h
    add  bl,al
    mov  byte [bx],ah        ;setup filename

    mov  ax,3d00h
    mov  dx,82h
    int  21h            ;open file

    xchg ax,bx

    mov  ah,3fh
    mov  cx,40768
    mov  dx,filebuffer
    int  21h            ;read file

    mov  ax,13h
    int  10h

    push word 0A000h
    pop  es

    mov  si,dx          ;begin palette setup
    xor  al,al
    mov  dx,03C8h
    out  dx,al
    inc  dx
nextcolor:
    lodsb
    out  dx,al
    cmp  si,img
    jne  nextcolor      ;complete palette is set


mainloop:

    mov  di,200
    sub  di,[size]
    imul di,160
    mov  ax,160
    mov  bx,[size]
    shr  bx,1
    sub  ax,bx
    add  di,ax          ;start offset calculated

    shl  ax,1
    mov  [lineadd],ax   ;lineadd calculated

    mov  bx,[size]
    xor  dx,dx
    mov  [y],dx
    mov  ax,200<<8
    div  bx
    mov  [d],ax       ;d calculated & y reseted

waitret:
    mov  dx,03DAh
.loop1:
    in   al,dx
    test al,8
    jnz  .loop1
.loop2:
    in   al,dx
    test al,8
    jz   .loop2

    mov  dx,[size]    ;begin drawing image
    mov  si,img
nextline:
    mov  cx,[size]
    xor  bx,bx
.nextpixel:
    add  bx,[d]
    push bx
    shr  bx,8
    mov  al,[si+bx]
    stosb
    pop  bx
    dec  cx
    jnz  .nextpixel
    mov  bx,[y]
    add  bx,[d]
    mov  [y],bx
    mov  ax,200
    mul  bh
    mov  si,img
    add  si,ax
    add  di,[lineadd]
    dec  dx
    jnz  nextline

    mov  ax,100h
    int  16h
    jnz   end

    mov  ax,[size]
    add  ax,[value]
    mov  [size],ax
    cmp  ax,50
    jne  nextcheck
    mov  word [value],2
    jmp  mainloop
nextcheck:
    cmp  ax,200
    je   otheradd
    jmp  mainloop
otheradd:
    mov  word [value],-2
    jmp  mainloop
end:
    mov  ax,3h
    int  10h

    int  20h


[SEGMENT .data]
size  dw 200
value dw -2

[SEGMENT .bss]		;Uninitialised data segment
lineadd resw 1
d resw 1
y resw 1

filebuffer:
pal resb 768
img resb 40000
